1. Packages
  2. Packages
  3. Pulumi Cloud (Pulumi Service provider)
  4. API Docs
  5. api
  6. api/esc
  7. Webhook

This provider is currently in preview.

Viewing docs for Pulumi Cloud v1.1.0
published on Thursday, May 21, 2026 by Pulumi
pulumiservice logo

This provider is currently in preview.

Viewing docs for Pulumi Cloud v1.1.0
published on Thursday, May 21, 2026 by Pulumi

    Creates a new webhook for a Pulumi ESC environment. Webhooks allow external services to be notified when environment events occur, such as updates or opens. The request body specifies the webhook configuration including the destination URL, event filters, and format. Returns 400 if the organization name in the request body does not match the URL path parameter. Returns 409 if a webhook with the same name already exists.

    Create Webhook Resource

    Resources are created with functions called constructors. To learn more about declaring and configuring resources, see Resources.

    Constructor syntax

    new Webhook(name: string, args: WebhookArgs, opts?: CustomResourceOptions);
    @overload
    def Webhook(resource_name: str,
                args: WebhookArgs,
                opts: Optional[ResourceOptions] = None)
    
    @overload
    def Webhook(resource_name: str,
                opts: Optional[ResourceOptions] = None,
                active: Optional[bool] = None,
                display_name: Optional[str] = None,
                env_name: Optional[str] = None,
                name: Optional[str] = None,
                organization_name: Optional[str] = None,
                payload_url: Optional[str] = None,
                project_name: Optional[str] = None,
                filters: Optional[Sequence[str]] = None,
                format: Optional[str] = None,
                groups: Optional[Sequence[str]] = None,
                secret: Optional[str] = None,
                stack_name: Optional[str] = None)
    func NewWebhook(ctx *Context, name string, args WebhookArgs, opts ...ResourceOption) (*Webhook, error)
    public Webhook(string name, WebhookArgs args, CustomResourceOptions? opts = null)
    public Webhook(String name, WebhookArgs args)
    public Webhook(String name, WebhookArgs args, CustomResourceOptions options)
    
    type: pulumiservice:api/esc:Webhook
    properties: # The arguments to resource properties.
    options: # Bag of options to control resource's behavior.
    
    
    resource "pulumiservice_api_esc_webhook" "name" {
        # resource properties
    }

    Parameters

    name string
    The unique name of the resource.
    args WebhookArgs
    The arguments to resource properties.
    opts CustomResourceOptions
    Bag of options to control resource's behavior.
    resource_name str
    The unique name of the resource.
    args WebhookArgs
    The arguments to resource properties.
    opts ResourceOptions
    Bag of options to control resource's behavior.
    ctx Context
    Context object for the current deployment.
    name string
    The unique name of the resource.
    args WebhookArgs
    The arguments to resource properties.
    opts ResourceOption
    Bag of options to control resource's behavior.
    name string
    The unique name of the resource.
    args WebhookArgs
    The arguments to resource properties.
    opts CustomResourceOptions
    Bag of options to control resource's behavior.
    name String
    The unique name of the resource.
    args WebhookArgs
    The arguments to resource properties.
    options CustomResourceOptions
    Bag of options to control resource's behavior.

    Constructor example

    The following reference example uses placeholder values for all input properties.

    var webhookResource = new PulumiService.Api.Esc.Webhook("webhookResource", new()
    {
        Active = false,
        DisplayName = "string",
        EnvName = "string",
        Name = "string",
        OrganizationName = "string",
        PayloadUrl = "string",
        ProjectName = "string",
        Filters = new[]
        {
            "string",
        },
        Format = "string",
        Groups = new[]
        {
            "string",
        },
        Secret = "string",
        StackName = "string",
    });
    
    example, err := esc.NewWebhook(ctx, "webhookResource", &esc.WebhookArgs{
    	Active:           pulumi.Bool(false),
    	DisplayName:      pulumi.String("string"),
    	EnvName:          pulumi.String("string"),
    	Name:             pulumi.String("string"),
    	OrganizationName: pulumi.String("string"),
    	PayloadUrl:       pulumi.String("string"),
    	ProjectName:      pulumi.String("string"),
    	Filters: pulumi.StringArray{
    		pulumi.String("string"),
    	},
    	Format: pulumi.String("string"),
    	Groups: pulumi.StringArray{
    		pulumi.String("string"),
    	},
    	Secret:    pulumi.String("string"),
    	StackName: pulumi.String("string"),
    })
    
    resource "pulumiservice_api_esc_webhook" "webhookResource" {
      active            = false
      display_name      = "string"
      env_name          = "string"
      name              = "string"
      organization_name = "string"
      payload_url       = "string"
      project_name      = "string"
      filters           = ["string"]
      format            = "string"
      groups            = ["string"]
      secret            = "string"
      stack_name        = "string"
    }
    
    var webhookResource = new com.pulumi.pulumiservice.api.Webhook("webhookResource", com.pulumi.pulumiservice.api.WebhookArgs.builder()
        .active(false)
        .displayName("string")
        .envName("string")
        .name("string")
        .organizationName("string")
        .payloadUrl("string")
        .projectName("string")
        .filters("string")
        .format("string")
        .groups("string")
        .secret("string")
        .stackName("string")
        .build());
    
    webhook_resource = pulumiservice.api.esc.Webhook("webhookResource",
        active=False,
        display_name="string",
        env_name="string",
        name="string",
        organization_name="string",
        payload_url="string",
        project_name="string",
        filters=["string"],
        format="string",
        groups=["string"],
        secret="string",
        stack_name="string")
    
    const webhookResource = new pulumiservice.api.esc.Webhook("webhookResource", {
        active: false,
        displayName: "string",
        envName: "string",
        name: "string",
        organizationName: "string",
        payloadUrl: "string",
        projectName: "string",
        filters: ["string"],
        format: "string",
        groups: ["string"],
        secret: "string",
        stackName: "string",
    });
    
    type: pulumiservice:api/esc:Webhook
    properties:
        active: false
        displayName: string
        envName: string
        filters:
            - string
        format: string
        groups:
            - string
        name: string
        organizationName: string
        payloadUrl: string
        projectName: string
        secret: string
        stackName: string
    

    Webhook Resource Properties

    To learn more about resource properties and how to use them, see Inputs and Outputs in the Architecture and Concepts docs.

    Inputs

    In Python, inputs that are objects can be passed either as argument classes or as dictionary literals.

    The Webhook resource accepts the following input properties:

    Active bool
    Whether the webhook is active and will receive deliveries.
    DisplayName string
    The human-readable display name shown in the UI.
    EnvName string
    The environment name. Set when the webhook is scoped to a specific environment.
    Name string
    The unique identifier name for the webhook within its scope.
    OrganizationName string
    The organization that owns this webhook.
    PayloadUrl string
    The URL to which webhook payloads are delivered.
    ProjectName string
    The project name. Set when the webhook is scoped to a specific stack.
    Filters List<string>
    Specific event types this webhook subscribes to. If empty, all events are delivered.
    Format string
    The format of the webhook payload (e.g., 'raw', 'slack', 'ms_teams').
    Groups List<string>
    Event groups this webhook subscribes to (e.g., 'stacks', 'deployments').
    Secret string
    Secret will be omitted when returned from the service.
    StackName string
    The stack name. Set when the webhook is scoped to a specific stack.
    Active bool
    Whether the webhook is active and will receive deliveries.
    DisplayName string
    The human-readable display name shown in the UI.
    EnvName string
    The environment name. Set when the webhook is scoped to a specific environment.
    Name string
    The unique identifier name for the webhook within its scope.
    OrganizationName string
    The organization that owns this webhook.
    PayloadUrl string
    The URL to which webhook payloads are delivered.
    ProjectName string
    The project name. Set when the webhook is scoped to a specific stack.
    Filters []string
    Specific event types this webhook subscribes to. If empty, all events are delivered.
    Format string
    The format of the webhook payload (e.g., 'raw', 'slack', 'ms_teams').
    Groups []string
    Event groups this webhook subscribes to (e.g., 'stacks', 'deployments').
    Secret string
    Secret will be omitted when returned from the service.
    StackName string
    The stack name. Set when the webhook is scoped to a specific stack.
    active bool
    Whether the webhook is active and will receive deliveries.
    display_name string
    The human-readable display name shown in the UI.
    env_name string
    The environment name. Set when the webhook is scoped to a specific environment.
    name string
    The unique identifier name for the webhook within its scope.
    organization_name string
    The organization that owns this webhook.
    payload_url string
    The URL to which webhook payloads are delivered.
    project_name string
    The project name. Set when the webhook is scoped to a specific stack.
    filters list(string)
    Specific event types this webhook subscribes to. If empty, all events are delivered.
    format string
    The format of the webhook payload (e.g., 'raw', 'slack', 'ms_teams').
    groups list(string)
    Event groups this webhook subscribes to (e.g., 'stacks', 'deployments').
    secret string
    Secret will be omitted when returned from the service.
    stack_name string
    The stack name. Set when the webhook is scoped to a specific stack.
    active Boolean
    Whether the webhook is active and will receive deliveries.
    displayName String
    The human-readable display name shown in the UI.
    envName String
    The environment name. Set when the webhook is scoped to a specific environment.
    name String
    The unique identifier name for the webhook within its scope.
    organizationName String
    The organization that owns this webhook.
    payloadUrl String
    The URL to which webhook payloads are delivered.
    projectName String
    The project name. Set when the webhook is scoped to a specific stack.
    filters List<String>
    Specific event types this webhook subscribes to. If empty, all events are delivered.
    format String
    The format of the webhook payload (e.g., 'raw', 'slack', 'ms_teams').
    groups List<String>
    Event groups this webhook subscribes to (e.g., 'stacks', 'deployments').
    secret String
    Secret will be omitted when returned from the service.
    stackName String
    The stack name. Set when the webhook is scoped to a specific stack.
    active boolean
    Whether the webhook is active and will receive deliveries.
    displayName string
    The human-readable display name shown in the UI.
    envName string
    The environment name. Set when the webhook is scoped to a specific environment.
    name string
    The unique identifier name for the webhook within its scope.
    organizationName string
    The organization that owns this webhook.
    payloadUrl string
    The URL to which webhook payloads are delivered.
    projectName string
    The project name. Set when the webhook is scoped to a specific stack.
    filters string[]
    Specific event types this webhook subscribes to. If empty, all events are delivered.
    format string
    The format of the webhook payload (e.g., 'raw', 'slack', 'ms_teams').
    groups string[]
    Event groups this webhook subscribes to (e.g., 'stacks', 'deployments').
    secret string
    Secret will be omitted when returned from the service.
    stackName string
    The stack name. Set when the webhook is scoped to a specific stack.
    active bool
    Whether the webhook is active and will receive deliveries.
    display_name str
    The human-readable display name shown in the UI.
    env_name str
    The environment name. Set when the webhook is scoped to a specific environment.
    name str
    The unique identifier name for the webhook within its scope.
    organization_name str
    The organization that owns this webhook.
    payload_url str
    The URL to which webhook payloads are delivered.
    project_name str
    The project name. Set when the webhook is scoped to a specific stack.
    filters Sequence[str]
    Specific event types this webhook subscribes to. If empty, all events are delivered.
    format str
    The format of the webhook payload (e.g., 'raw', 'slack', 'ms_teams').
    groups Sequence[str]
    Event groups this webhook subscribes to (e.g., 'stacks', 'deployments').
    secret str
    Secret will be omitted when returned from the service.
    stack_name str
    The stack name. Set when the webhook is scoped to a specific stack.
    active Boolean
    Whether the webhook is active and will receive deliveries.
    displayName String
    The human-readable display name shown in the UI.
    envName String
    The environment name. Set when the webhook is scoped to a specific environment.
    name String
    The unique identifier name for the webhook within its scope.
    organizationName String
    The organization that owns this webhook.
    payloadUrl String
    The URL to which webhook payloads are delivered.
    projectName String
    The project name. Set when the webhook is scoped to a specific stack.
    filters List<String>
    Specific event types this webhook subscribes to. If empty, all events are delivered.
    format String
    The format of the webhook payload (e.g., 'raw', 'slack', 'ms_teams').
    groups List<String>
    Event groups this webhook subscribes to (e.g., 'stacks', 'deployments').
    secret String
    Secret will be omitted when returned from the service.
    stackName String
    The stack name. Set when the webhook is scoped to a specific stack.

    Outputs

    All input properties are implicitly available as output properties. Additionally, the Webhook resource produces the following output properties:

    HasSecret bool
    HasSecret is true if the webhook has a secret. This is used to determine whether to show that there is a secret in the UI.
    Id string
    The provider-assigned unique ID for this managed resource.
    SecretCiphertext string
    SecretCiphertext is the ciphertext value of the webhook's secret. It's used to check whether the secret was changed by the PSP
    HasSecret bool
    HasSecret is true if the webhook has a secret. This is used to determine whether to show that there is a secret in the UI.
    Id string
    The provider-assigned unique ID for this managed resource.
    SecretCiphertext string
    SecretCiphertext is the ciphertext value of the webhook's secret. It's used to check whether the secret was changed by the PSP
    has_secret bool
    HasSecret is true if the webhook has a secret. This is used to determine whether to show that there is a secret in the UI.
    id string
    The provider-assigned unique ID for this managed resource.
    secret_ciphertext string
    SecretCiphertext is the ciphertext value of the webhook's secret. It's used to check whether the secret was changed by the PSP
    hasSecret Boolean
    HasSecret is true if the webhook has a secret. This is used to determine whether to show that there is a secret in the UI.
    id String
    The provider-assigned unique ID for this managed resource.
    secretCiphertext String
    SecretCiphertext is the ciphertext value of the webhook's secret. It's used to check whether the secret was changed by the PSP
    hasSecret boolean
    HasSecret is true if the webhook has a secret. This is used to determine whether to show that there is a secret in the UI.
    id string
    The provider-assigned unique ID for this managed resource.
    secretCiphertext string
    SecretCiphertext is the ciphertext value of the webhook's secret. It's used to check whether the secret was changed by the PSP
    has_secret bool
    HasSecret is true if the webhook has a secret. This is used to determine whether to show that there is a secret in the UI.
    id str
    The provider-assigned unique ID for this managed resource.
    secret_ciphertext str
    SecretCiphertext is the ciphertext value of the webhook's secret. It's used to check whether the secret was changed by the PSP
    hasSecret Boolean
    HasSecret is true if the webhook has a secret. This is used to determine whether to show that there is a secret in the UI.
    id String
    The provider-assigned unique ID for this managed resource.
    secretCiphertext String
    SecretCiphertext is the ciphertext value of the webhook's secret. It's used to check whether the secret was changed by the PSP

    Package Details

    Repository
    pulumiservice pulumi/pulumi-pulumiservice
    License
    Apache-2.0
    pulumiservice logo

    This provider is currently in preview.

    Viewing docs for Pulumi Cloud v1.1.0
    published on Thursday, May 21, 2026 by Pulumi

      Try Pulumi Cloud free.
      Your team will thank you.

      Start free trial